diff -urN src/gtk2/gui/guiDownloads.ml src/gtk2/gui/guiDownloads.ml
--- src/gtk2/gui/guiDownloads.ml	2005-05-13 23:15:47.000000000 +0200
+++ src/gtk2/gui/guiDownloads.ml	2005-10-31 13:24:43.000000000 +0100
@@ -22,6 +22,7 @@
 open GuiTypes2
 open GuiTypes
 open CommonTypes
+open GraphTypes
 
 open GuiTools
 open GuiColumns
@@ -84,13 +85,139 @@
      source_upload_rate = 0.;
      source_download_rate = 0.;
      source_upload = None;
-     source_has_upload = false;
+     source_has_upload = source_only;
      source_availability = [];
      source_files_requested = [];
   }
 
 (*************************************************************************)
 (*                                                                       *)
+(*                         is_file                                       *)
+(*                                                                       *)
+(*************************************************************************)
+
+let is_file key = not (String.contains key ':')
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         is_source                                     *)
+(*                                                                       *)
+(*************************************************************************)
+
+let is_source key = (snd (String2.cut_at key ':') <> "")
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         file_num                                      *)
+(*                                                                       *)
+(*************************************************************************)
+
+let file_num key =
+  if is_file key || is_source key
+  then begin
+    let t = fst (String2.cut_at key ':') in
+    int_of_string t
+  end else raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         source_num                                    *)
+(*                                                                       *)
+(*************************************************************************)
+
+let source_num key =
+  if is_source key
+  then begin
+    let t = snd (String2.cut_at key ':') in
+    int_of_string t
+  end else raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         file_of_key                                   *)
+(*                                                                       *)
+(*************************************************************************)
+
+let file_of_key key =
+  try
+    let num = file_num key in
+    Hashtbl.find G.files num
+  with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         source_of_key                                 *)
+(*                                                                       *)
+(*************************************************************************)
+
+let source_of_key key =
+  try
+    let num = source_num key in
+    Hashtbl.find G.sources num
+  with _ -> raise Not_found
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         keys_to_files                                 *)
+(*                                                                       *)
+(*************************************************************************)
+
+let keys_to_files keys =
+  let l = ref [] in
+  List.iter (fun k ->
+    try
+      if (is_file k) then
+        let f = file_of_key k in
+        if not (List.memq f !l) then
+          l := f :: !l
+    with _ -> ()) keys;
+  !l
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         keys_to_sources                               *)
+(*                                                                       *)
+(*************************************************************************)
+
+let keys_to_sources keys =
+  let l = ref [] in
+  List.iter (fun k ->
+    try
+      let s = source_of_key k in
+      if not (List.memq s !l)
+        then l := s :: !l
+    with _ -> ()) keys;
+  !l
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         file_key                                      *)
+(*                                                                       *)
+(*************************************************************************)
+
+let file_key file_num =
+  Printf.sprintf "%d" file_num
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         source_key                                    *)
+(*                                                                       *)
+(*************************************************************************)
+
+let source_key file_num source_num =
+  Printf.sprintf "%d:%d" file_num source_num
+
+(*************************************************************************)
+(*                                                                       *)
+(*                         dummy_source_key                              *)
+(*                                                                       *)
+(*************************************************************************)
+
+let dummy_source_key file_num =
+  source_key file_num dummy_source.source_num
+
+(*************************************************************************)
+(*                                                                       *)
 (*                         Templates                                     *)
 (*                                                                       *)
 (*************************************************************************)
@@ -98,8 +225,8 @@
 let get_key =
   (fun i ->
      match i with
-         File f -> File_num f.file_num
-       | Source (s, file_num) -> Source_num (s.source_num, file_num)
+         File f -> (Printf.sprintf "%d" f.g_file_num)
+       | Source (s, file_num) -> (Printf.sprintf "%d:%d" file_num s.source_num)
   )
 
 module Downloads = GuiTemplates.Gview(struct
@@ -107,7 +234,6 @@
   module Column = GuiColumns.File
 
   type item = item_info
-  type key  = item_index
 
   let columns = O.downloads_columns
   let get_key = get_key
@@ -151,32 +277,31 @@
       match i with
           File f ->
             begin
-              store#set ~row ~column:download_network (Mi.network_name f.file_network);
-              store#set ~row ~column:download_network_pixb (Mi.network_pixb f.file_network ~size:A.SMALL ());
-              store#set ~row ~column:download_name (U.utf8_of f.file_name);
-              store#set ~row ~column:download_name_pixb (Mi.file_type_of_name f.file_name ~size:A.SMALL);
-              store#set ~row ~column:download_uid (Mi.uid_list_to_string f.file_uids);
-              store#set ~row ~column:download_size (Mi.size_of_int64 f.file_size);
-              store#set ~row ~column:download_downloaded (Mi.size_of_int64 f.file_downloaded);
-              store#set ~row ~column:download_percent (Mi.get_percent_of f.file_downloaded f.file_size);
-              store#set ~row ~column:download_sources (Printf.sprintf "(%d / %d)" f.file_active_sources f.file_all_sources);
-              store#set ~row ~column:download_state (Mi.string_of_file_state f.file_state f.file_download_rate);
-              let availability = Mi.main_availability_of f.file_network f.file_availability in
-              store#set ~row ~column:download_availability (Mi.string_of_availability availability f.file_chunks);
-              store#set ~row ~column:download_availability_pixb (Mi.availability_bar availability f.file_chunks true);
-              store#set ~row ~column:download_download_rate (Mi.rate_to_string f.file_download_rate);
-              store#set ~row ~column:download_format (Mi.format_to_string f.file_format);
-              store#set ~row ~column:download_age (Mi.time_to_string f.file_age);
-              store#set ~row ~column:download_last_seen (Mi.time_to_string f.file_last_seen);
-              store#set ~row ~column:download_eta_inst (Mi.calc_eta_inst f.file_size f.file_downloaded f.file_download_rate);
-              store#set ~row ~column:download_eta_average (Mi.calc_eta_average f.file_size f.file_downloaded f.file_age);
-              store#set ~row ~column:download_priority (Mi.priority_to_string f.file_priority);
-              store#set ~row ~column:download_comment (U.utf8_of f.file_comment)
+              store#set ~row ~column:download_network (Mi.network_name f.g_file_network);
+              store#set ~row ~column:download_network_pixb (Mi.network_pixb f.g_file_network ~size:A.SMALL ());
+              store#set ~row ~column:download_name (U.utf8_of f.g_file_name);
+              store#set ~row ~column:download_name_pixb (Mi.file_type_of_name f.g_file_name ~size:A.SMALL);
+              store#set ~row ~column:download_uid (Mi.uid_list_to_string f.g_file_uids);
+              store#set ~row ~column:download_size (Mi.size_of_int64 f.g_file_size);
+              store#set ~row ~column:download_downloaded (Mi.size_of_int64 f.g_file_downloaded);
+              store#set ~row ~column:download_percent (Mi.get_percent_of f.g_file_downloaded f.g_file_size);
+              store#set ~row ~column:download_sources (Printf.sprintf "(%d / %d)" f.g_file_active_sources f.g_file_all_sources);
+              store#set ~row ~column:download_state (Mi.string_of_file_state f.g_file_state f.g_file_download_rate);
+              let availability = Mi.main_availability_of f.g_file_network f.g_file_availability in
+              store#set ~row ~column:download_availability (Mi.string_of_availability availability f.g_file_chunks);
+              store#set ~row ~column:download_availability_pixb (Mi.availability_bar availability f.g_file_chunks true);
+              store#set ~row ~column:download_download_rate (Mi.rate_to_string f.g_file_download_rate);
+              store#set ~row ~column:download_format (Mi.format_to_string f.g_file_format);
+              store#set ~row ~column:download_age (Mi.time_to_string f.g_file_age);
+              store#set ~row ~column:download_last_seen (Mi.time_to_string f.g_file_last_seen);
+              store#set ~row ~column:download_eta_inst (Mi.calc_eta_inst f.g_file_size f.g_file_downloaded f.g_file_download_rate);
+              store#set ~row ~column:download_eta_average (Mi.calc_eta_average f.g_file_size f.g_file_downloaded f.g_file_age);
+              store#set ~row ~column:download_priority (Mi.priority_to_string f.g_file_priority);
+              store#set ~row ~column:download_comment (U.utf8_of f.g_file_comment)
             end
         | Source (s, file_num) ->
             try
-              let (_, i) = self#find_item (File_num file_num) in
-              let f = match i with File f -> f | _ -> raise Exit in
+              let f = Hashtbl.find G.files file_num in
               if s.source_num = (-1)
                 then begin
                   store#set ~row ~column:download_name s.source_name;
@@ -194,8 +319,8 @@
                   store#set ~row ~column:download_downloaded (Mi.size_of_int64 s.source_downloaded);
                   store#set ~row ~column:download_percent s.source_software;
                   store#set ~row ~column:download_state (Mi.string_of_state s.source_state file_num);
-                  store#set ~row ~column:download_availability (Mi.string_of_availability availability f.file_chunks);
-                  store#set ~row ~column:download_availability_pixb (Mi.availability_bar availability f.file_chunks false);
+                  store#set ~row ~column:download_availability (Mi.string_of_availability availability f.g_file_chunks);
+                  store#set ~row ~column:download_availability_pixb (Mi.availability_bar availability f.g_file_chunks false);
                   store#set ~row ~column:download_download_rate (Mi.rate_to_string s.source_download_rate);
                 end
             with _ -> ()
@@ -210,68 +335,67 @@
       match (i, i_new) with
           (File f, File f_new) ->
             begin
-              if f.file_comment <> f_new.file_comment
+              if f.g_file_comment <> f_new.g_file_comment
                 then begin
-                  store#set ~row ~column:download_comment (U.utf8_of f_new.file_comment)
+                  store#set ~row ~column:download_comment (U.utf8_of f_new.g_file_comment)
                 end;
-              if f.file_name <> f_new.file_name
+              if f.g_file_name <> f_new.g_file_name
                 then begin
-                  store#set ~row ~column:download_name (U.utf8_of f_new.file_name);
-                  if (Mi.extension_of f.file_name) <> (Mi.extension_of f_new.file_name)
+                  store#set ~row ~column:download_name (U.utf8_of f_new.g_file_name);
+                  if (Mi.extension_of f.g_file_name) <> (Mi.extension_of f_new.g_file_name)
                     then begin
-                      store#set ~row ~column:download_name_pixb (Mi.file_type_of_name f_new.file_name ~size:A.SMALL);
+                      store#set ~row ~column:download_name_pixb (Mi.file_type_of_name f_new.g_file_name ~size:A.SMALL);
                     end
                 end;
-              if f.file_uids <> f_new.file_uids
+              if f.g_file_uids <> f_new.g_file_uids
                 then begin
-                  store#set ~row ~column:download_uid (Mi.uid_list_to_string f.file_uids);
+                  store#set ~row ~column:download_uid (Mi.uid_list_to_string f.g_file_uids);
                 end;
-              if (f.file_size, f.file_downloaded, f.file_download_rate, f.file_age) <>
-                 (f_new.file_size, f_new.file_downloaded, f_new.file_download_rate, f_new.file_age)
+              if (f.g_file_size, f.g_file_downloaded, f.g_file_download_rate, f.g_file_age) <>
+                 (f_new.g_file_size, f_new.g_file_downloaded, f_new.g_file_download_rate, f_new.g_file_age)
                 then begin
-                  store#set ~row ~column:download_downloaded (Mi.size_of_int64 f_new.file_downloaded);
-                  store#set ~row ~column:download_percent (Mi.get_percent_of f_new.file_downloaded f_new.file_size);
-                  store#set ~row ~column:download_size (Mi.size_of_int64 f_new.file_size);
-                  store#set ~row ~column:download_age (Mi.time_to_string f_new.file_age);
-                  store#set ~row ~column:download_download_rate (Mi.rate_to_string f_new.file_download_rate);
-                  store#set ~row ~column:download_eta_inst (Mi.calc_eta_inst f_new.file_size f_new.file_downloaded
-                                                                             f_new.file_download_rate);
-                  store#set ~row ~column:download_eta_average (Mi.calc_eta_average f_new.file_size
-                                                                                   f_new.file_downloaded f_new.file_age);
+                  store#set ~row ~column:download_downloaded (Mi.size_of_int64 f_new.g_file_downloaded);
+                  store#set ~row ~column:download_percent (Mi.get_percent_of f_new.g_file_downloaded f_new.g_file_size);
+                  store#set ~row ~column:download_size (Mi.size_of_int64 f_new.g_file_size);
+                  store#set ~row ~column:download_age (Mi.time_to_string f_new.g_file_age);
+                  store#set ~row ~column:download_download_rate (Mi.rate_to_string f_new.g_file_download_rate);
+                  store#set ~row ~column:download_eta_inst (Mi.calc_eta_inst f_new.g_file_size f_new.g_file_downloaded
+                                                                             f_new.g_file_download_rate);
+                  store#set ~row ~column:download_eta_average (Mi.calc_eta_average f_new.g_file_size
+                                                                                   f_new.g_file_downloaded f_new.g_file_age);
                 end;
-              if (f.file_state, f.file_download_rate) <> (f_new.file_state, f_new.file_download_rate)
+              if (f.g_file_state, f.g_file_download_rate) <> (f_new.g_file_state, f_new.g_file_download_rate)
                 then begin
-                  store#set ~row ~column:download_state (Mi.string_of_file_state f_new.file_state f_new.file_download_rate);
+                  store#set ~row ~column:download_state (Mi.string_of_file_state f_new.g_file_state f_new.g_file_download_rate);
                 end;
-              let availability = Mi.main_availability_of f.file_network f.file_availability in
-              let availability_new = Mi.main_availability_of f_new.file_network f_new.file_availability in
-              if (availability, f.file_chunks) <> (availability_new, f_new.file_chunks)
+              let availability = Mi.main_availability_of f.g_file_network f.g_file_availability in
+              let availability_new = Mi.main_availability_of f_new.g_file_network f_new.g_file_availability in
+              if (availability, f.g_file_chunks) <> (availability_new, f_new.g_file_chunks)
                 then begin
-                  store#set ~row ~column:download_availability (Mi.string_of_availability availability_new f_new.file_chunks);
-                  store#set ~row ~column:download_availability_pixb (Mi.availability_bar availability_new f_new.file_chunks true);
+                  store#set ~row ~column:download_availability (Mi.string_of_availability availability_new f_new.g_file_chunks);
+                  store#set ~row ~column:download_availability_pixb (Mi.availability_bar availability_new f_new.g_file_chunks true);
                 end;
-              if f.file_format <> f_new.file_format
+              if f.g_file_format <> f_new.g_file_format
                 then begin
-                  store#set ~row ~column:download_format (Mi.format_to_string f_new.file_format);
+                  store#set ~row ~column:download_format (Mi.format_to_string f_new.g_file_format);
                 end;
-              if f.file_last_seen <> f_new.file_last_seen
+              if f.g_file_last_seen <> f_new.g_file_last_seen
                 then begin
-                  store#set ~row ~column:download_last_seen (Mi.time_to_string f_new.file_last_seen);
+                  store#set ~row ~column:download_last_seen (Mi.time_to_string f_new.g_file_last_seen);
                 end;
-              if f.file_priority <> f_new.file_priority
+              if f.g_file_priority <> f_new.g_file_priority
                 then begin
-                  store#set ~row ~column:download_priority (Mi.priority_to_string f_new.file_priority);
+                  store#set ~row ~column:download_priority (Mi.priority_to_string f_new.g_file_priority);
                 end;
-              if (f.file_active_sources, f.file_all_sources) <> (f_new.file_active_sources, f_new.file_all_sources)
+              if (f.g_file_active_sources, f.g_file_all_sources) <> (f_new.g_file_active_sources, f_new.g_file_all_sources)
                 then begin
-                  store#set ~row ~column:download_sources (Printf.sprintf "(%d / %d)" f_new.file_active_sources f_new.file_all_sources);
+                  store#set ~row ~column:download_sources (Printf.sprintf "(%d / %d)" f_new.g_file_active_sources f_new.g_file_all_sources);
                 end
             end
 
         | (Source (s, file_num), Source (s_new, file_num_new)) when file_num = file_num_new ->
            (try
-              let (_, i) = self#find_item (File_num file_num) in
-              let f = match i with File f -> f | _ -> raise Exit in
+              let f = Hashtbl.find G.files file_num in
               if s.source_num <> (-1)
                 then begin
                   if s.source_name <> s_new.source_name
@@ -306,8 +430,8 @@
                   in
                   if availability <> new_availability
                     then begin
-                      store#set ~row ~column:download_availability (Mi.string_of_availability new_availability f.file_chunks);
-                      store#set ~row ~column:download_availability_pixb (Mi.availability_bar new_availability f.file_chunks false)
+                      store#set ~row ~column:download_availability (Mi.string_of_availability new_availability f.g_file_chunks);
+                      store#set ~row ~column:download_availability_pixb (Mi.availability_bar new_availability f.g_file_chunks false)
                     end;
                   if s_new.source_download_rate <> s.source_download_rate
                     then begin
@@ -337,48 +461,43 @@
               let renderer = GTree.cell_renderer_text [`XALIGN 0.] in
               col#pack ~expand:false renderer;
               col#set_cell_data_func renderer
-               (fun model row ->
-                  match !view_context with
-                      Some context when col#width > 0 ->
-                        begin
-                          let width =
-                            if !!O.gtk_look_use_icons
-                              then (col#width - 4 - !!O.gtk_look_lists_icon_size) - 4 * !G.char_width
-                              else col#width - 4 * !G.char_width
-                          in
-                          let name = model#get ~row ~column:download_name in
-                          let s = GuiTools.fit_string_to_pixels name ~context ~pixels:width in
-                          renderer#set_properties [ `TEXT s ];
-                          let item = self#get_item row in
-                          begin
-                            match item with
-                                File f ->
-                                  renderer#set_properties [ `EDITABLE true ];
-                                  ignore (renderer#connect#edited ~callback:
-                                    (fun path name ->
-                                       try
-                                         let iter = self#get_iter path in
-                                         let item = self#get_item iter in
-                                         match item with
-                                             File ff ->
-                                               let child_row = self#convert_iter_to_child_iter iter in
-                                               store#set ~row:child_row ~column:download_name ff.file_name;
-                                               (match ff.file_state with
-                                                   FileDownloaded  -> GuiCom.send (SaveFile (ff.file_num, name))
-                                                 | _  ->  GuiCom.send (RenameFile (ff.file_num, name)))
-                                           | _ -> ()
-
-                                       with _ -> ()
+                (fun model row ->
+                   match !view_context with
+                       Some context when col#width > 0 ->
+                         begin
+                           let width =
+                             if !!O.gtk_look_use_icons
+                               then (col#width - 4 - !!O.gtk_look_lists_icon_size) - 4 * !G.char_width
+                               else col#width - 4 * !G.char_width
+                           in
+                           let name = model#get ~row ~column:download_name in
+                           let s = GuiTools.fit_string_to_pixels name ~context ~pixels:width in
+                           renderer#set_properties [ `TEXT s ];
+                           let key = self#find_model_key row in
+                           if (is_file key) then begin
+                             renderer#set_properties [ `EDITABLE true ];
+                             ignore (renderer#connect#edited ~callback:
+                               (fun path name ->
+                                  try
+                                    let iter = self#get_iter path in
+                                    let k = self#find_model_key iter in
+                                    if (is_file k) then begin
+                                      let file = file_of_key k in
+                                      (match file.g_file_state with
+                                           FileDownloaded  -> GuiCom.send (SaveFile (file.g_file_num, name))
+                                         | _  ->  GuiCom.send (RenameFile (file.g_file_num, name)));
+                                      let store_iter = self#convert_iter_to_child_iter iter in
+                                      store#set ~row:store_iter ~column:download_name file.g_file_name
+                                    end
+                                  with _ -> ()
                                   ))
 
-                              | _ -> renderer#set_properties [ `EDITABLE false ]
-
-                          end
-                        end
+                             end else renderer#set_properties [ `EDITABLE false ]
+                         end
 
                       | _ -> renderer#set_properties [ `TEXT "" ]
-              )
-           end
+                )
+            end
 
         | Col_file_size ->
             begin
